<template>
  <div class="ec-sort mr-md-2 mt-0 mt-md-3 ">
    <div class="d-inline align-middle colorPrimarySort font-weight-bold mr-2">Sort by:</div>
    <div class="col-right mr-md-2 d-inline" role="group" aria-label="Sort Dropdown">
      <div class="btn-group ec-sort-dropdown" role="group">
        <button class="colorPrimarySort value-display list-group-item col w-100 d-flex flex-row justify-content-md-between p-0 align-items-center"
                id="btnGroupDrop1" type="button" data-toggle="dropdown" aria-expanded="false">
          <div class="pl-2 h-100 d-flex align-items-center">
            {{ sortSelectedLabel }}
          </div>
          <div class="ecl-select__icon ecl-select__icon-Sort">
            <svg class="
                        ecl-icon ecl-icon--s ecl-icon--rotate-180
                        ecl-select__icon-shape
                      " focusable="false" aria-hidden="true">
              <use xlink:href="@/assets/img/ecl/icons.svg#corner-arrow"></use>
            </svg>
          </div>
        </button>
        <ul class="dropdown-menu ec-ds-dropdown-items" aria-labelledby="btnGroupDrop1">
          <button class="dropdown-item" @click="
                    setSortMethod(
                      'modified',
                      'desc',
                      $t('message.sort.lastModified')
                    )
                    ">
            {{ $t("message.sort.lastUpdated") }}
          </button>
          <button class="dropdown-item" @click="
                    setSortMethod(
                      'relevance',
                      'desc',
                      $t('message.sort.relevance')
                    )
                    ">
            {{ $t("message.sort.relevance") }}
          </button>
          <button class="dropdown-item" @click="
                    setSortMethod(
                      `title.${$route.query.locale}`,
                      'asc',
                      $t('message.sort.nameAZ')
                    )
                    ">
            {{ $t("message.sort.nameAZ") }}
          </button>
          <button class="dropdown-item" @click="
                    setSortMethod(
                      `title.${$route.query.locale}`,
                      'desc',
                      $t('message.sort.nameZA')
                    )
                    ">
            {{ $t("message.sort.nameZA") }}
          </button>
          <button class="dropdown-item" @click="
                    setSortMethod(
                      'issued',
                      'desc',
                      $t('message.sort.lastCreated')
                    )
                    ">
            {{ $t("message.sort.lastCreated") }}
          </button>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  name: "SearchSortDropdown",
  props: {
    config: Object
  },
  data() {
    return {
      sortSelected: "",
      sortSelectedLabel: this.$t("message.sort.relevance"),
    }
  },
  watch: {
    sortSelected: {
      handler(sort) {
        this.$router
          .replace({ query: Object.assign({}, this.$route.query, { sort }) })
          .catch((error) => {
            console.error(error);
          });
        this.setSort(sort);
      },
      deep: true,
    },
  },
  methods: {
    setSort(sort) {
      this.$store.dispatch(`${this.config.setSort[0]}/${this.config.setSort[1]}`, sort);
    },
    initSort() {
      let sort = this.$route.query.sort;
      if (sort) {
        sort = sort.split(",")[0].toLowerCase();
        if (sort.includes("title")) {
          if (sort.includes("desc")) {
            this.sortSelectedLabel = this.$t("message.sort.nameZA");
            this.setSortMethod(
              `title.${this.$route.query.locale}`,
              "desc",
              this.$t("message.sort.nameZA")
            );
          } else {
            this.sortSelectedLabel = this.$t("message.sort.nameAZ");
            this.setSortMethod(
              `title.${this.$route.query.locale}`,
              "asc",
              this.$t("message.sort.nameAZ")
            );
          }
        } else {
          if (sort === "relevance+desc") {
            this.sortSelectedLabel = this.$t("message.sort.relevance");
            this.setSortMethod(
              "relevance",
              "desc",
              this.$t("message.sort.relevance")
            );
          }
          if (sort === "modified+desc") {
            this.sortSelectedLabel = this.$t("message.sort.lastUpdated");
            this.setSortMethod(
              "modified",
              "desc",
              this.$t("message.sort.lastUpdated")
            );
          }
          if (sort === "issued+desc") {
            this.sortSelectedLabel = this.$t("message.sort.lastCreated");
            this.setSortMethod(
              "issued",
              "desc",
              this.$t("message.sort.lastCreated")
            );
          }
        }
      } else {
        this.setSort(
          `relevance+desc, modified+desc, title.${this.$route.query.locale}+asc`
        );
      }
    },
    setSortMethod(method, order, label) {
      this.sortSelectedLabel = label;
      if (method === "relevance")
        this.sortSelected = `${method}+${order}, modified+desc, title.${this.$route.query.locale}+asc`;
      if (method === "modified")
        this.sortSelected = `${method}+${order}, relevance+desc, title.${this.$route.query.locale}+asc`;
      if (method === `title.${this.$route.query.locale}`)
        this.sortSelected = `${method}+${order}, relevance+desc, modified+desc`;
      if (method === "issued")
        this.sortSelected = `${method}+${order}, relevance+desc, title.${this.$route.query.locale}+asc`;
      return this.sortSelected;
    },
  },
  created() {
    this.$nextTick(() => {
      this.initSort();
    });
  }
}
</script>

<style lang="scss" scoped>
.ec-ds-dropdown-items .nav-item .router-link-active {
  background-color: #0e47cb !important;
  color: #fff !important;
}

.dropdown-item {
  &:active {
    background-color: var(--dropdown-item-active-bg);
  }
}

@media screen and (max-width: 767.5px) {
  .ec-ds-dropdown-items {
    width: 100% !important;
  }
}
</style>
